*//	LZE DECODE ROUTINE
*//	Original Copyright (C)1995,2008 GORRY.
*//	Porting for 6809 by Kei Moroboshi 2020/Apr

COPYCOUNT	EQU	0		;Stack Frame Offset
BITCOUNT	EQU	1		;So you sould NOT change those.
BITDATA		EQU	2
FRAMESIZE	EQU	BITDATA+1

*==============================================================================
*LZE data decoder
*Input:
*	X	LZE encoded data address(*)
*	U	extracting address
*(*)lze.exe add 4 byte header as extracted size(big-endian).
*Therefore, you must set X as LZE data top + 4(skip the header).
*Broken:
*	D,X,Y,U,CC
*Example:
*	LDX	#LZE_DATA+4
*	LDU	#EXTRACT_AREA
*	JSR	DECODE_LZE
*==============================================================================

DECODE_LZE:			;Entry
	LEAS	-FRAMESIZE,S
	LDB	#1		; BitCount=1
STORE:
	STA	BITDATA,S
	LDA	,X+		; *(DECODEPtr++) = *(LZEPtr++);
	STA	,U+		; U'=DECODEPtr
	LDA	BITDATA,S
MAINLP:
	DECB			;BitTest() {
	BNE	SKIP
	LDA	,X+
	LDB	#8
SKIP:	ASLA			;}
	BCS	STORE		;1:Store
				;0x:Copy

;Copy Byte Distance or Word Distance
	DECB			;BitTest() {
	BNE	SKIP0
	LDA	,X+
	LDB	#8
SKIP0:	ASLA			;}
	BCS	COPYWD		;01:Copy with Word Distance
				;00:Copy with Byte Distance
	CLR	COPYCOUNT,S	;CopyCount=0;
COPYBD:
	DECB			;BitTest() {
	BNE	SKIP00
	LDA	,X+
	LDB	#8
SKIP00:	ASLA			;}

	ROL	COPYCOUNT,S	;adc	CopyCount,CopyCount

	DECB			;BitTest() {
	BNE	SKIP01
	LDA	,X+
	LDB	#8
SKIP01:	ASLA

	ROL	COPYCOUNT,S	;adc	CopyCount,CopyCount

	STD	BITCOUNT,S	;save AB
	LDB	,X+		;	Distance = -256+((int)*(LZEPtr++));
	LDA	#$FF
	LEAY	D,U		;Y:CopyPtr=Distance + U:DECODEPtr
	LDA	COPYCOUNT,S
CPCNTP2:		;CopyCount ++;
	INCA		;inc	CopyCount
CPCNTP1:
	INCA		;inc	CopyCount
LDIR:	LDB	,Y+		;copy
	STB	,U+
	DECA
	BNE	LDIR
	LDD	BITCOUNT,S	;restore D
	BRA	MAINLP

;COPY with Word Distance
COPYWD:
	STD	BITCOUNT,S	;save D
	LDD	,X++		;LoadDistanceW
	STB	COPYCOUNT,S	;mov	CopyCount,Distance
	LSRA			;shr	Distance,1
	RORB
	LSRA			;shr	Distance,1
	RORB
	LSRA			;shr	Distance,1
	RORB
	ORA	#$E0		;or	DistanceH,0e0h
	LEAY	D,U		;Y:CopyPtr=Distance + U:DECODEPtr

	LDA	COPYCOUNT,S
	ANDA	#7
	BNE	CPCNTP2
	LDA	,X+		;Load CopyCount-2
	BNE	CPCNTP1

DECODE_LZE_e:
	LEAS	FRAMESIZE,S
	RTS
